package net.t2code.alias.Spigot.config.config;

import net.minecraft.world.level.levelgen.DensityFunctions;
import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.system.AliasRegister;
import net.t2code.alias.Spigot.objects.AliasObjekt;
import net.t2code.alias.Util;
import net.t2code.lib.Spigot.Lib.messages.send;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class SelectAlias {
    private static String Prefix = Util.getPrefix();

    public static void onSelect() {

        Main.aliasHashMap.clear();
        Main.allAliases.clear();
        File f = new File(Main.getPath() + "/Alias/");
        File[] fileArray = f.listFiles();
        for (File config_gui : fileArray) {
            if (config_gui.getName().equals("X_aliasDeclaration_X.yml")) continue;
            String sub = config_gui.getName().substring(config_gui.getName().length() - 4);
            if (sub.equals(".yml")) {

                YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config_gui);

                Boolean aliasEnable = yamlConfiguration.getBoolean("Alias.Enable");
                List<String> aliasList;
                if (yamlConfiguration.get("Alias.AliasList") != null) {
                    aliasList  = yamlConfiguration.getStringList("Alias.AliasList");
                } else aliasList  = Collections.singletonList(config_gui.getName().toLowerCase());

                Boolean permNecessary = yamlConfiguration.getBoolean("Alias.Permission.Necessary");

                Boolean costEnable = yamlConfiguration.getBoolean("Alias.Cost.Enable");
                Double costPrice = yamlConfiguration.getDouble("Alias.Cost.Price");
                Boolean costAllowBypass = yamlConfiguration.getBoolean("Alias.Cost.AllowByPass");

                Boolean commandEnable = yamlConfiguration.getBoolean("Alias.Command.Enable");
                Boolean commandAsConsole = yamlConfiguration.getBoolean("Alias.Command.CommandAsConsole");
                Boolean bungeeCommand = yamlConfiguration.getBoolean("Alias.Command.BungeeCommand");
                List<String> command = yamlConfiguration.getStringList("Alias.Command.Commands");

                Boolean messageEnable = yamlConfiguration.getBoolean("Alias.Message.Enable");
                List<String> messages = yamlConfiguration.getStringList("Alias.Message.Messages");

                Boolean adminEnable = yamlConfiguration.getBoolean("Alias.Admin.Enable");
                String adminPermission = yamlConfiguration.getString("Alias.Admin.Permission");

                Boolean adminCommandEnable = yamlConfiguration.getBoolean("Alias.Admin.Command.Enable");
                Boolean adminCommandAsConsole = yamlConfiguration.getBoolean("Alias.Admin.Command.CommandAsConsole");
                Boolean adminBungeeCommand = yamlConfiguration.getBoolean("Alias.Admin.Command.BungeeCommand");
                List<String> adminCommands = yamlConfiguration.getStringList("Alias.Admin.Command.Commands");

                Boolean adminMessageEnable = yamlConfiguration.getBoolean("Alias.Admin.Message.Enable");
                List<String> adminMessages = yamlConfiguration.getStringList("Alias.Admin.Message.Messages");

                Boolean consoleEnable = yamlConfiguration.getBoolean("Alias.Console.Enable");
                Boolean consoleCommandEnable = yamlConfiguration.getBoolean("Alias.Console.Command.Enable");
                Boolean consoleBungeeCommand = yamlConfiguration.getBoolean("Alias.Console.Command.BungeeCommand");
                List<String> consoleCommands = yamlConfiguration.getStringList("Alias.Console.Command.Commands");
                Boolean consoleMessageEnable = yamlConfiguration.getBoolean("Alias.Console.Message.Enable");
                List<String> consoleMessages = yamlConfiguration.getStringList("Alias.Console.Message.Messages");

                Main.allAliases.addAll(aliasList);
                AliasObjekt alias = new AliasObjekt(aliasEnable, aliasList, permNecessary, costEnable, costPrice, costAllowBypass, commandEnable, commandAsConsole, bungeeCommand,
                        command, messageEnable, messages, adminEnable, adminPermission, adminCommandEnable, adminCommandAsConsole, adminBungeeCommand, adminCommands,
                        adminMessageEnable, adminMessages, consoleEnable, consoleCommandEnable, consoleBungeeCommand, consoleCommands, consoleMessageEnable, consoleMessages);

                for (String al : aliasList) {
                    Main.aliasHashMap.put(al, alias);
                }
            }
        }
        AliasRegister.onRegister();
    }
}
