package net.t2code.alias.Spigot.config.config;

import net.minecraft.world.level.levelgen.DensityFunctions;
import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.objects.SubAliasObjekt;
import net.t2code.alias.Spigot.system.AliasRegister;
import net.t2code.alias.Spigot.objects.AliasObjekt;
import net.t2code.alias.Util;
import net.t2code.lib.Spigot.Lib.messages.send;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.List;

public class SelectSubAlias {
    private static String Prefix = Util.getPrefix();

    public static void onSelect() {

        Main.aliasHashMap.clear();
        Main.allAliases.clear();
        File f = new File(Main.getPath() + "/SubAlias/");
        File[] fileArray = f.listFiles();
        for (File config_gui : fileArray) {
            if (config_gui.getName().equals("X_subAliasDeclaration_X.yml")) continue;
            String sub = config_gui.getName().substring(config_gui.getName().length() - 4);
            if (sub.equals(".yml")) {

                YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config_gui);

                Boolean aliasEnable = yamlConfiguration.getBoolean("SubAlias.Enable");
                List<String> subAliasList = yamlConfiguration.getStringList("SubAlias.SubAliasList");
                String subAliasFor = yamlConfiguration.getString("SubAlias.SubAliasFor");
                Integer subAliasArg = yamlConfiguration.getInt("SubAlias.SubAliasArg");
                Boolean permNecessary = yamlConfiguration.getBoolean("SubAlias.Permission.Necessary");

                Boolean costEnable = yamlConfiguration.getBoolean("SubAlias.Cost.Enable");
                Double costPrice = yamlConfiguration.getDouble("SubAlias.Cost.Price");
                Boolean costAllowBypass = yamlConfiguration.getBoolean("SubAlias.Cost.AllowByPass");

                Boolean commandEnable = yamlConfiguration.getBoolean("SubAlias.Command.Enable");
                Boolean commandAsConsole = yamlConfiguration.getBoolean("SubAlias.Command.CommandAsConsole");
                Boolean bungeeCommand = yamlConfiguration.getBoolean("SubAlias.Command.BungeeCommand");
                List<String> command = yamlConfiguration.getStringList("SubAlias.Command.Commands");

                Boolean messageEnable = yamlConfiguration.getBoolean("SubAlias.Message.Enable");
                List<String> messages = yamlConfiguration.getStringList("SubAlias.Message.Messages");

                Boolean adminEnable = yamlConfiguration.getBoolean("SubAlias.Admin.Enable");
                String adminPermission = yamlConfiguration.getString("SubAlias.Admin.Permission");

                Boolean adminCommandEnable = yamlConfiguration.getBoolean("SubAlias.Admin.Command.Enable");
                Boolean adminCommandAsConsole = yamlConfiguration.getBoolean("SubAlias.Admin.Command.CommandAsConsole");
                Boolean adminBungeeCommand = yamlConfiguration.getBoolean("SubAlias.Admin.Command.BungeeCommand");
                List<String> adminCommands = yamlConfiguration.getStringList("SubAlias.Admin.Command.Commands");

                Boolean adminMessageEnable = yamlConfiguration.getBoolean("SubAlias.Admin.Message.Enable");
                List<String> adminMessages = yamlConfiguration.getStringList("SubAlias.Admin.Message.Messages");

                Boolean consoleEnable = yamlConfiguration.getBoolean("SubAlias.Console.Enable");
                Boolean consoleCommandEnable = yamlConfiguration.getBoolean("SubAlias.Console.Command.Enable");
                Boolean consoleBungeeCommand = yamlConfiguration.getBoolean("SubAlias.Console.Command.BungeeCommand");
                List<String> consoleCommands = yamlConfiguration.getStringList("SubAlias.Console.Command.Commands");
                Boolean consoleMessageEnable = yamlConfiguration.getBoolean("SubAlias.Console.Message.Enable");
                List<String> consoleMessages = yamlConfiguration.getStringList("SubAlias.Console.Message.Messages");

                SubAliasObjekt subAlias = new SubAliasObjekt(aliasEnable, subAliasList, subAliasFor, subAliasArg, permNecessary, costEnable, costPrice, costAllowBypass, commandEnable, commandAsConsole, bungeeCommand,
                        command, messageEnable, messages, adminEnable, adminPermission, adminCommandEnable, adminCommandAsConsole, adminBungeeCommand, adminCommands,
                        adminMessageEnable, adminMessages, consoleEnable, consoleCommandEnable, consoleBungeeCommand, consoleCommands, consoleMessageEnable, consoleMessages);
                for (String sal : subAliasList) {
                    Main.subAliasHashMap.put(sal, subAlias);
                }
                Main.allSubAliases.addAll(subAliasList);
            }
        }
    }
}
